from cpl_core.application import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC
from cpl_discord.service import DiscordBotServiceABC

from bot_data.model.technician_config import TechnicianConfig


class InitBotExtension(ApplicationExtensionABC):
    def __init__(self):
        ApplicationExtensionABC.__init__(self)

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        settings = config.get_configuration(TechnicianConfig)

        bot: DiscordBotServiceABC = services.get_service(DiscordBotServiceABC, max_messages=settings.cache_max_messages)
