from abc import ABC, abstractmethod
from datetime import datetime


class HistoryTableABC(ABC):
    @abstractmethod
    def __init__(self):
        self._id = 0
        self._deleted = False
        self._date_from = datetime.now().isoformat()
        self._date_to = datetime.now().isoformat()

    @property
    def id(self) -> int:
        return self._id

    @property
    def deleted(self) -> bool:
        return self._deleted

    @property
    def date_from(self) -> str:
        return self._date_from

    @property
    def date_to(self) -> str:
        return self._date_to
