import { User } from "../data/user.model";
import { AutoRole, AutoRoleRule } from "../data/auto_role.model";
import { Level } from "../data/level.model";
import { Server } from "../data/server.model";
import { Achievement } from "../data/achievement.model";
import { TechnicianConfig } from "../config/technician-config.model";
import { ServerConfig } from "../config/server-config.model";

export interface GraphQLResult {
  data: {
    servers?: Server[];
  };
  errors?: [];
}

export interface QueryResult {
  data: {
    servers?: Server[];
  };
}

export interface UpdateUserMutationResult {
  user: {
    updateUser: User
  };
}

export interface AutoRoleMutationResult {
  autoRole: {
    createAutoRole?: AutoRole
    updateAutoRole?: AutoRole
    deleteAutoRole?: AutoRole
  };
}

export interface AutoRoleRuleMutationResult {
  autoRoleRule: {
    createAutoRoleRule?: AutoRoleRule
    updateAutoRoleRule?: AutoRoleRule
    deleteAutoRoleRule?: AutoRoleRule
  };
}

export interface LevelMutationResult {
  level: {
    createLevel?: Level
    updateLevel?: Level
    deleteLevel?: Level
  };
}

export interface TechnicianConfigMutationResult {
  technicianConfig: {
    updateTechnicianConfig?: TechnicianConfig
  };
}

export interface ServerConfigMutationResult {
  serverConfig: {
    updateServerConfig?: ServerConfig
  };
}

export interface AchievementMutationResult {
  achievement: {
    createAchievement?: Achievement
    updateAchievement?: Achievement
    deleteAchievement?: Achievement
  };
}
